<template>
    <el-button @click="toggleDark()" style="width:30px; height:30px; padding:1.5rem; position:absolute; right:0; margin-right:0.5rem;">
        <img  :src="isDark ? `/svg/moon.svg` : `/svg/sun.svg`" alt="SVG" />
    </el-button>

    <div class="login-container">
        
        <el-card v-loading="loading" class="login-card">
            <div class="logo-container margin-bottom-md">
            <img class="logo" src="imgs/logo.jpg"/>
          </div>

            <h2 class="no-margin">Login</h2>
            <p class="no-margin-top" @click="() => router.push('register')">Register here.</p>
            <el-form ref="formRef" :model="form" :size="formSize" :rules="rules">
                <el-form-item v-for="item in formItems" :prop="item.id">
                    <el-input :class="item.class" :type="item.type" :id="item.id" v-model="form[item.id]" :placeholder="`${item.id.charAt(0).toUpperCase()}${item.id.slice(1)}`" :show-password="item.type=='password'"/>
                </el-form-item>
                <el-form-item prop="remember">
                    <el-checkbox id="remember" v-model="form.remember" label="Remember me"/>
                </el-form-item>

                <el-form-item class="">
                    <el-button @click="login" >Login</el-button>
                    <el-button @click="resetForm">Reset</el-button>
                </el-form-item>
                <el-form-item>

                </el-form-item>
            </el-form>
        </el-card>
    </div>
</template>

<style lang="scss" scoped>
@import '../../../../sass/app.scss';


h2, p {
    color: var(--el-color-primary)
}

p:hover{
    cursor: pointer;
    color: hsl(0, 0%, 69%)
}

.login-container {
    display: flex;
    justify-content: center;
    align-items: center;
    height: 800px;
}

.login-card {
    width: 400px;
    max-width: 90%;
    padding: 20px;

    --el-card-border-color: none;
}

.el-button {
    --el-button-hover-bg-color:none;
}

.logo-container{
    width:100%;
    display:flex;
    justify-content: center;
}
.logo{
    width:150px;
    height:150px;
    border-radius:100%;
    object-fit:cover;
    box-shadow:1px 5px 1px rgb(104, 104, 104);
}



</style>


<script setup>
import {ref, onMounted, onBeforeUnmount} from "vue"
import { useRouter } from 'vue-router';
import adminHandler from "../../helpers/userHandler"
import formHelper from "../../helpers/form"
import { useDark, useToggle } from "@vueuse/core";

const router = useRouter();
const { formSize, formRef, form, resetForm, rules } = formHelper
const { loading, performRequest } = adminHandler

const formItems = ref(
    [
        {
            'class': 'nmpsm',
            'id': 'email',
            'type': 'email'
        },
        {
            'class': 'nmpsm',
            'id': 'password',
            'type': 'password'
        },
    ]
)
const login = async () => {
    const URL_login = "/api/user/login";
    const payloadProperties = ['email', 'password', 'remember'];
    const requestType = 'login'
    await performRequest(URL_login, payloadProperties, requestType, router);
};

const handleLogin = (event) => {
      if (event.keyCode === 13) {
        event.preventDefault();
        login();
    }
};


onMounted( () => {
    document.body.addEventListener('keydown', handleLogin);
})

onBeforeUnmount( () => {
    document.body.removeEventListener('keydown', handleLogin);
})

const isDark = useDark();
const toggleDark = useToggle(isDark);
</script>
